/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
 */

///
/// This file was automatically generated from the AMQP specification.
/// Do not edit.
///


#include "qpid/framing/AMQHeaderBody.h"
#include "qpid/framing/AMQContentBody.h"
#include "qpid/framing/AMQHeartbeatBody.h"
#include "qpid/framing/ConnectionStartBody.h"
#include "qpid/framing/ConnectionStartOkBody.h"
#include "qpid/framing/ConnectionSecureBody.h"
#include "qpid/framing/ConnectionSecureOkBody.h"
#include "qpid/framing/ConnectionTuneBody.h"
#include "qpid/framing/ConnectionTuneOkBody.h"
#include "qpid/framing/ConnectionOpenBody.h"
#include "qpid/framing/ConnectionOpenOkBody.h"
#include "qpid/framing/ConnectionRedirectBody.h"
#include "qpid/framing/ConnectionHeartbeatBody.h"
#include "qpid/framing/ConnectionCloseBody.h"
#include "qpid/framing/ConnectionCloseOkBody.h"
#include "qpid/framing/SessionAttachBody.h"
#include "qpid/framing/SessionAttachedBody.h"
#include "qpid/framing/SessionDetachBody.h"
#include "qpid/framing/SessionDetachedBody.h"
#include "qpid/framing/SessionRequestTimeoutBody.h"
#include "qpid/framing/SessionTimeoutBody.h"
#include "qpid/framing/SessionCommandPointBody.h"
#include "qpid/framing/SessionExpectedBody.h"
#include "qpid/framing/SessionConfirmedBody.h"
#include "qpid/framing/SessionCompletedBody.h"
#include "qpid/framing/SessionKnownCompletedBody.h"
#include "qpid/framing/SessionFlushBody.h"
#include "qpid/framing/SessionGapBody.h"
#include "qpid/framing/ExecutionSyncBody.h"
#include "qpid/framing/ExecutionResultBody.h"
#include "qpid/framing/ExecutionExceptionBody.h"
#include "qpid/framing/MessageTransferBody.h"
#include "qpid/framing/MessageAcceptBody.h"
#include "qpid/framing/MessageRejectBody.h"
#include "qpid/framing/MessageReleaseBody.h"
#include "qpid/framing/MessageAcquireBody.h"
#include "qpid/framing/MessageResumeBody.h"
#include "qpid/framing/MessageSubscribeBody.h"
#include "qpid/framing/MessageCancelBody.h"
#include "qpid/framing/MessageSetFlowModeBody.h"
#include "qpid/framing/MessageFlowBody.h"
#include "qpid/framing/MessageFlushBody.h"
#include "qpid/framing/MessageStopBody.h"
#include "qpid/framing/TxSelectBody.h"
#include "qpid/framing/TxCommitBody.h"
#include "qpid/framing/TxRollbackBody.h"
#include "qpid/framing/DtxSelectBody.h"
#include "qpid/framing/DtxStartBody.h"
#include "qpid/framing/DtxEndBody.h"
#include "qpid/framing/DtxCommitBody.h"
#include "qpid/framing/DtxForgetBody.h"
#include "qpid/framing/DtxGetTimeoutBody.h"
#include "qpid/framing/DtxPrepareBody.h"
#include "qpid/framing/DtxRecoverBody.h"
#include "qpid/framing/DtxRollbackBody.h"
#include "qpid/framing/DtxSetTimeoutBody.h"
#include "qpid/framing/ExchangeDeclareBody.h"
#include "qpid/framing/ExchangeDeleteBody.h"
#include "qpid/framing/ExchangeQueryBody.h"
#include "qpid/framing/ExchangeBindBody.h"
#include "qpid/framing/ExchangeUnbindBody.h"
#include "qpid/framing/ExchangeBoundBody.h"
#include "qpid/framing/QueueDeclareBody.h"
#include "qpid/framing/QueueDeleteBody.h"
#include "qpid/framing/QueuePurgeBody.h"
#include "qpid/framing/QueueQueryBody.h"
#include "qpid/framing/FileQosBody.h"
#include "qpid/framing/FileQosOkBody.h"
#include "qpid/framing/FileConsumeBody.h"
#include "qpid/framing/FileConsumeOkBody.h"
#include "qpid/framing/FileCancelBody.h"
#include "qpid/framing/FileOpenBody.h"
#include "qpid/framing/FileOpenOkBody.h"
#include "qpid/framing/FileStageBody.h"
#include "qpid/framing/FilePublishBody.h"
#include "qpid/framing/FileReturnBody.h"
#include "qpid/framing/FileDeliverBody.h"
#include "qpid/framing/FileAckBody.h"
#include "qpid/framing/FileRejectBody.h"
#include "qpid/framing/StreamQosBody.h"
#include "qpid/framing/StreamQosOkBody.h"
#include "qpid/framing/StreamConsumeBody.h"
#include "qpid/framing/StreamConsumeOkBody.h"
#include "qpid/framing/StreamCancelBody.h"
#include "qpid/framing/StreamPublishBody.h"
#include "qpid/framing/StreamReturnBody.h"
#include "qpid/framing/StreamDeliverBody.h"
#include "qpid/framing/ClusterJoinedBody.h"
#include "qpid/framing/ClusterConnectionDeliverCloseBody.h"
#include "qpid/framing/ClusterConnectionDeliverDoOutputBody.h"

#include <algorithm>
#include <fstream>

using namespace std;
using namespace qpid::framing;

int main(int, char** argv) {
    size_t maxSize=0;
    maxSize=max(maxSize, sizeof(AMQHeaderBody));
    maxSize=max(maxSize, sizeof(AMQContentBody));
    maxSize=max(maxSize, sizeof(AMQHeartbeatBody));
    maxSize=max(maxSize, sizeof(ConnectionStartBody));
    maxSize=max(maxSize, sizeof(ConnectionStartOkBody));
    maxSize=max(maxSize, sizeof(ConnectionSecureBody));
    maxSize=max(maxSize, sizeof(ConnectionSecureOkBody));
    maxSize=max(maxSize, sizeof(ConnectionTuneBody));
    maxSize=max(maxSize, sizeof(ConnectionTuneOkBody));
    maxSize=max(maxSize, sizeof(ConnectionOpenBody));
    maxSize=max(maxSize, sizeof(ConnectionOpenOkBody));
    maxSize=max(maxSize, sizeof(ConnectionRedirectBody));
    maxSize=max(maxSize, sizeof(ConnectionHeartbeatBody));
    maxSize=max(maxSize, sizeof(ConnectionCloseBody));
    maxSize=max(maxSize, sizeof(ConnectionCloseOkBody));
    maxSize=max(maxSize, sizeof(SessionAttachBody));
    maxSize=max(maxSize, sizeof(SessionAttachedBody));
    maxSize=max(maxSize, sizeof(SessionDetachBody));
    maxSize=max(maxSize, sizeof(SessionDetachedBody));
    maxSize=max(maxSize, sizeof(SessionRequestTimeoutBody));
    maxSize=max(maxSize, sizeof(SessionTimeoutBody));
    maxSize=max(maxSize, sizeof(SessionCommandPointBody));
    maxSize=max(maxSize, sizeof(SessionExpectedBody));
    maxSize=max(maxSize, sizeof(SessionConfirmedBody));
    maxSize=max(maxSize, sizeof(SessionCompletedBody));
    maxSize=max(maxSize, sizeof(SessionKnownCompletedBody));
    maxSize=max(maxSize, sizeof(SessionFlushBody));
    maxSize=max(maxSize, sizeof(SessionGapBody));
    maxSize=max(maxSize, sizeof(ExecutionSyncBody));
    maxSize=max(maxSize, sizeof(ExecutionResultBody));
    maxSize=max(maxSize, sizeof(ExecutionExceptionBody));
    maxSize=max(maxSize, sizeof(MessageTransferBody));
    maxSize=max(maxSize, sizeof(MessageAcceptBody));
    maxSize=max(maxSize, sizeof(MessageRejectBody));
    maxSize=max(maxSize, sizeof(MessageReleaseBody));
    maxSize=max(maxSize, sizeof(MessageAcquireBody));
    maxSize=max(maxSize, sizeof(MessageResumeBody));
    maxSize=max(maxSize, sizeof(MessageSubscribeBody));
    maxSize=max(maxSize, sizeof(MessageCancelBody));
    maxSize=max(maxSize, sizeof(MessageSetFlowModeBody));
    maxSize=max(maxSize, sizeof(MessageFlowBody));
    maxSize=max(maxSize, sizeof(MessageFlushBody));
    maxSize=max(maxSize, sizeof(MessageStopBody));
    maxSize=max(maxSize, sizeof(TxSelectBody));
    maxSize=max(maxSize, sizeof(TxCommitBody));
    maxSize=max(maxSize, sizeof(TxRollbackBody));
    maxSize=max(maxSize, sizeof(DtxSelectBody));
    maxSize=max(maxSize, sizeof(DtxStartBody));
    maxSize=max(maxSize, sizeof(DtxEndBody));
    maxSize=max(maxSize, sizeof(DtxCommitBody));
    maxSize=max(maxSize, sizeof(DtxForgetBody));
    maxSize=max(maxSize, sizeof(DtxGetTimeoutBody));
    maxSize=max(maxSize, sizeof(DtxPrepareBody));
    maxSize=max(maxSize, sizeof(DtxRecoverBody));
    maxSize=max(maxSize, sizeof(DtxRollbackBody));
    maxSize=max(maxSize, sizeof(DtxSetTimeoutBody));
    maxSize=max(maxSize, sizeof(ExchangeDeclareBody));
    maxSize=max(maxSize, sizeof(ExchangeDeleteBody));
    maxSize=max(maxSize, sizeof(ExchangeQueryBody));
    maxSize=max(maxSize, sizeof(ExchangeBindBody));
    maxSize=max(maxSize, sizeof(ExchangeUnbindBody));
    maxSize=max(maxSize, sizeof(ExchangeBoundBody));
    maxSize=max(maxSize, sizeof(QueueDeclareBody));
    maxSize=max(maxSize, sizeof(QueueDeleteBody));
    maxSize=max(maxSize, sizeof(QueuePurgeBody));
    maxSize=max(maxSize, sizeof(QueueQueryBody));
    maxSize=max(maxSize, sizeof(FileQosBody));
    maxSize=max(maxSize, sizeof(FileQosOkBody));
    maxSize=max(maxSize, sizeof(FileConsumeBody));
    maxSize=max(maxSize, sizeof(FileConsumeOkBody));
    maxSize=max(maxSize, sizeof(FileCancelBody));
    maxSize=max(maxSize, sizeof(FileOpenBody));
    maxSize=max(maxSize, sizeof(FileOpenOkBody));
    maxSize=max(maxSize, sizeof(FileStageBody));
    maxSize=max(maxSize, sizeof(FilePublishBody));
    maxSize=max(maxSize, sizeof(FileReturnBody));
    maxSize=max(maxSize, sizeof(FileDeliverBody));
    maxSize=max(maxSize, sizeof(FileAckBody));
    maxSize=max(maxSize, sizeof(FileRejectBody));
    maxSize=max(maxSize, sizeof(StreamQosBody));
    maxSize=max(maxSize, sizeof(StreamQosOkBody));
    maxSize=max(maxSize, sizeof(StreamConsumeBody));
    maxSize=max(maxSize, sizeof(StreamConsumeOkBody));
    maxSize=max(maxSize, sizeof(StreamCancelBody));
    maxSize=max(maxSize, sizeof(StreamPublishBody));
    maxSize=max(maxSize, sizeof(StreamReturnBody));
    maxSize=max(maxSize, sizeof(StreamDeliverBody));
    maxSize=max(maxSize, sizeof(ClusterJoinedBody));
    maxSize=max(maxSize, sizeof(ClusterConnectionDeliverCloseBody));
    maxSize=max(maxSize, sizeof(ClusterConnectionDeliverDoOutputBody));
    ofstream out("qpid/framing/MaxMethodBodySize.h");
    out << "// GENERATED CODE: generated by " << argv[0] << endl;
    out << "namespace qpid{ namespace framing { " << endl;
    out << "const size_t MAX_METHOD_BODY_SIZE=" << maxSize << ";" << endl;
    out << "}}" << endl;
}
